<template>
  <b-navbar :toggleable="toogleVar[2]" :type="typeVar[0]" :variant="navbarVar[0]" :class="navbarClass[3]">
    <b-navbar-brand href="#">
      <img src="../../assets/img/logo-header.png" width="120" alt="Aerial Group" />
    </b-navbar-brand>

    <b-navbar-toggle target="nav-collapse"></b-navbar-toggle>

    <b-collapse id="nav-collapse" is-nav>
      <b-navbar-nav v-if="menuLoaded">
        <!-- Bouton accueil -->
        <b-nav-item href="/"><b-icon icon="house" font-scale=".9"></b-icon> Accueil</b-nav-item>

        <div v-for="(link, idx) in allLinks" :key="link.id">
          <!-- Niveau 1 -->
          <b-nav-item-dropdown id="'dropdown-1'" :text="link.libelle" right v-if="link.children && link.children.length > 0">
            <div v-for="(subLink, idx2) in link.children" :key="subLink.id">
              <b-dropdown-item v-if="link.disposition == 'Dropdown'">
                <router-link :to="'/' + subLink.slug">{{ subLink.libelle }}</router-link>
              </b-dropdown-item>
              <b-dropdown-item v-if="link.disposition == 'Haut-Catégories-dropdown' && subLink.children.length == 0">
                <router-link :to="'/' + link.slug + '/' + subLink.slug">{{ subLink.libelle }}</router-link>
              </b-dropdown-item>
              <!-- Niveau 2 -->
              <b-nav-item-dropdown id="dropdown-2" :text="subLink.libelle" class="mx-2" v-if="link.disposition == 'Haut-Catégories-dropdown' && subLink.children.length > 0">
                <div v-for="(subLink2, idx3) in subLink.children" :key="subLink2.id">
                  <b-dropdown-item v-if="subLink2.children.length == 0">
                    <router-link :to="'/' + link.slug + '/' + subLink.slug + '/' + subLink2.slug">{{ subLink2.title }}</router-link>
                  </b-dropdown-item>
                  <!-- Niveau 3 -->
                  <b-nav-item-dropdown id="dropdown-3" :text="subLink2.title" class="mx-2" v-if="subLink2.children.length > 0">
                    <div v-for="(subLink3, idx4) in subLink2.children" :key="subLink3.id">
                      <b-dropdown-item v-if="subLink3.children.length == 0">
                        <router-link :to="'/' + link.slug + '/' + subLink.slug + '/' + subLink2.slug + '/' + subLink3.slug">{{ subLink3.title }}</router-link>
                      </b-dropdown-item>
                      <!-- Niveau 4 -->
                      <b-nav-item-dropdown id="dropdown-4" :text="subLink3.title" class="mx-2" v-if="subLink3.children.length > 0">
                        <div v-for="(subLink4, idx5) in subLink3.children" :key="subLink4.id">
                          <b-dropdown-item>
                            <router-link :to="'/' + link.slug + '/' + subLink.slug + '/' + subLink2.slug + '/' + subLink3.slug + '/' + subLink4.slug">{{ subLink4.title }}</router-link>
                          </b-dropdown-item>
                        </div>
                      </b-nav-item-dropdown>
                    </div>
                  </b-nav-item-dropdown>
                </div>
              </b-nav-item-dropdown>
            </div>
          </b-nav-item-dropdown>

          <li class="nav-item" v-else>
            <router-link :to="'/' + link.slug" class="nav-link">{{ link.libelle }}</router-link>
          </li>
        </div>

        <!-- Mini panier -->
        <mini-cart></mini-cart>

        <!-- User login/logout non actif pour le moment-->
        <!--
        <b-nav-item-dropdown right>
          <template v-slot:button-content>
            <b-icon icon="person"></b-icon> User
          </template>
          <b-dropdown-item href="#">Profile</b-dropdown-item>
          <b-dropdown-item href="#">Sign Out</b-dropdown-item>
        </b-nav-item-dropdown>
        -->
      </b-navbar-nav>
    </b-collapse>
  </b-navbar>
</template>

<script>
import Vue from "vue";
import miniCart from "@/components/AppPanier/miniPanier.vue";
import jsonConfigBuilder from "@/config-data/config-products.json";
import jsonConfigRoutes from "@/config-data/config-routes.json";
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_CATEGORIES_LIST_FROM = URL_API + "api/categories-from-name/";

export default {
  components: {
    "mini-cart": miniCart
  },
  created: async function() {
    await this.fetchDataMenu();
  },
  mounted: function() {
    this.constructmenuJs();
  },
  data() {
    return {
      menuLoaded: false,
      jsonConfigBuilder,
      jsonConfigRoutes,
      allLinks: [],
      dropMenus: [],

      // Variables navbar

      // Point de rupture du toogle
      toggleable: "lg",
      toogleVar: ["sm", "md", "lg"],

      // Contraste du texte (light= text foncé, dark= texte clair)
      type: "light",
      typeVar: ["light", "dark"],

      // Couleur de font du navbar
      variant: "light",
      navbarVar: ["white", "light", "dark", "danger", "info", "warning", "success", "primary", "secondary"],

      // class additionelles
      class: "static-top",
      navbarClass: ["static-top", "fixed-top", "fixed-bottom", "sticky-top", "container"]
    };
  },

  methods: {
    constructmenuJs() {
      for (let i = 2; i < 5; i++) {
        let visible = false;
        switch (i) {
          case 2:
            visible = this.isDropdown2Visible;
            break;
          case 3:
            visible = this.isDropdown3Visible;
            break;
          case 4:
            visible = this.isDropdown4Visible;
            break;
        }
        this.$root.$on("bv::dropdown::show", bvEvent => {
          if (bvEvent.componentId === "dropdown-" + i) {
            visible = true;
          }
        });
        this.$root.$on("bv::dropdown::hide", bvEvent => {
          if (bvEvent.componentId === "dropdown-" + i) {
            visible = false;
          }
          if (visible) {
            bvEvent.preventDefault();
          }
        });
      }
    },
    async fetchDataMenu() {
      // on met tout les dropdown dans un menu a part
      this.jsonConfigRoutes.forEach(elm => {
        if (elm.disposition == "Dropdown" || elm.disposition == "Haut-Catégories-dropdown") {
          this.dropMenus.push(elm);
        }
      });

      let nbModulesDrop = this.dropMenus.filter(dm => {
        return dm.disposition == "Haut-Catégories-dropdown";
      }).length;

      let cpt = 0;
      this.dropMenus.forEach((eldrop, idx) => {
        eldrop.children = [];
        this.jsonConfigRoutes.forEach(elm => {
          if (elm.disposition == eldrop.libelle) {
            eldrop.children.push(elm);
          }
        });

        // construction children catégories pour base produit
        if (eldrop.disposition == "Haut-Catégories-dropdown") {
          if (eldrop.modules.length > 0) {
            eldrop.modules.forEach(modu => {
              if (modu.module.indexOf("produits") >= 0) {
                // liaison avec config builder catégories
                let selectedCategoriesModule = jsonConfigBuilder.filter(el => {
                  return el.module == modu.module;
                });
                console.log("selectedCategoriesModule", selectedCategoriesModule);
                // fetch data module catégories
                this.$axios
                  .get(URL_CATEGORIES_LIST_FROM + selectedCategoriesModule[0].confCatSlug)
                  .then(response => {
                    let tempRep = JSON.parse(response.data.data[0].data);
                    let menuProducts = JSON.parse(tempRep.categories);
                    // push dans le dropdown
                    menuProducts.forEach((elProducts, idxP) => {
                      // harmonisation clés json avec les autres
                      elProducts.libelle = elProducts.title;
                      elProducts.link = modu.slug;
                      eldrop.children.push(elProducts);
                    });
                    cpt++;
                    if (cpt == nbModulesDrop) {
                      this.menuLoaded = true;
                    }
                  })
                  .catch(error => {
                    console.log("error", error);
                  });
              }
            });
          }
        }
      });

      console.log("dropMenus AFTER", this.dropMenus);

      // filtre menu sur disposition Haut puis tri sur ordre
      this.allLinks = this.jsonConfigRoutes
        .filter(item => {
          return item.disposition == "Haut";
        })
        .filter(item => {
          return item.libelle !== "";
        });

      // on fusionne les tableaux de liens et dropdown
      this.allLinks = this.allLinks.concat(this.dropMenus).sort(function(a, b) {
        return parseFloat(a.ordre) - parseFloat(b.ordre);
      });

      console.log("allLinks", this.allLinks);
    }
  }

  // multilevel dropdown
  // mounted: function() {
  //   this.$root.$on("bv::dropdown::show", bvEvent => {
  //     if (bvEvent.componentId === "dropdown-2") {
  //       this.isDropdown2Visible = true;
  //     }
  //   });
  //   this.$root.$on("bv::dropdown::hide", bvEvent => {
  //     if (bvEvent.componentId === "dropdown-2") {
  //       this.isDropdown2Visible = false;
  //     }
  //     if (this.isDropdown2Visible) {
  //       bvEvent.preventDefault();
  //     }
  //   });
  // }
};
</script>
